package pboweaverplugin.view;

import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;

import pboweaverplugin.view.constructs.LabelledPbOObject;

class ViewLabelProvider extends LabelProvider implements ITableLabelProvider {
	@Override 
	public String getText(Object element) {
		
		if (element instanceof LabelledPbOObject) {
			LabelledPbOObject obj = (LabelledPbOObject)element;
			return obj.getText();
		}
		
		return "";
	}
	
	@Override
	public String getColumnText(Object obj, int index) {
		return getText(obj);
	}
	
	@Override
	public Image getColumnImage(Object obj, int index) {
		return getImage(obj);
	}
	
	@Override
	public Image getImage(Object obj) {
		if (obj instanceof LabelledPbOObject) {
			LabelledPbOObject item = (LabelledPbOObject)obj;
			return item.getImage();
		}
		
		return PlatformUI.getWorkbench().
				getSharedImages().getImage(ISharedImages.IMG_OBJ_ELEMENT);
	}
}