package pboweaverplugin.view.constructs;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;

import pboweaverplugin.view.model.Location;

public class PbOParameter extends AbstractPbOObject {
	
	public PbOParameter(String name, Location declared, List<Location> accessed) {
		super(name, declared, accessed);
	}

	@Override
	public String getText() {
		String filename = this.getDeclared().getFile().getName();
		int lineNumber = this.getDeclared().getLineNumber();
		
		return String.format("%s - %s: %d", this.getName(), filename, lineNumber);
	}
	
	@Override
	
	public Image getImage() {
		try {
			URL file = new URL("platform:/plugin/PbOWeaverPlugin/icons/var_declaration_obj.gif");
			ImageDescriptor id = ImageDescriptor.createFromURL(file);
			return id.createImage();
		} catch (MalformedURLException e) {
			e.printStackTrace();
			return super.getImage();
		}
	}
}
