package pboweaverplugin.view.model;

import java.net.MalformedURLException;
import java.net.URL;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;

import pboweaverplugin.view.constructs.LabelledPbOObject;

public class Location extends LabelledPbOObject {
	private IFile file;
	private int lineNumber;
	
	public Location(IFile file, int lineNumber) {
		this.file = file;
		this.lineNumber = lineNumber;
	}
	
	public IFile getFile() {
		return file;
	}
	
	public int getLineNumber() {
		return lineNumber;
	}
	
	public String getText() {
		String filename = this.getFile().getName();
		int lineNumber = this.getLineNumber();
		
		return String.format("%s: %d", filename, lineNumber);
	}
	
	public Image getImage() {
		try {
			URL file = new URL("platform:/plugin/PbOWeaverPlugin/icons/exec_obj.gif");
			ImageDescriptor id = ImageDescriptor.createFromURL(file);
			return id.createImage();
		} catch (MalformedURLException e) {
			e.printStackTrace();
			return super.getImage();
		}
	}
}
