package pboweaverplugin.view.model;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;

import pboweaverplugin.view.constructs.AbstractPbOObject;
import pboweaverplugin.view.constructs.LabelledPbOObject;

public abstract class PbOCategory extends LabelledPbOObject {
	List<AbstractPbOObject> items;
	
	/**
	 * This class represents a category to be displayed in the PbO View
	 * @param items
	 */
	public PbOCategory(List<AbstractPbOObject> items) {
		this.items = items;
	}
	
	/**
	 * Returns a list of PbO Objects to the view to be displayed
	 * @return
	 */
	
	public  List<AbstractPbOObject> getItems() { return items; }
	
	public Image getImage() {
		try {
			URL file = new URL("platform:/plugin/PbOWeaverPlugin/icons/open_incl.gif");
			ImageDescriptor id = ImageDescriptor.createFromURL(file);
			return id.createImage();
		} catch (MalformedURLException e) {
			e.printStackTrace();
			return super.getImage();
		}
	}

}
