package pboweaverplugin.view.model;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;

import pboweaverplugin.view.constructs.PbOBuilderFactory;
import pboweaverplugin.view.parser.PbOInfoParser;

public class PbOModel implements IPbOModel {
	protected IFile file;
	
	public PbOModel(IFile file) {
		this.file = file;
	}
	

	public List<PbOCategory> getPbOConstructs() {
		try {
			PbOInfoParser parser = new PbOInfoParser(file, PbOBuilderFactory.getParamBuilder(), PbOBuilderFactory.getChoiceBuilder(), PbOBuilderFactory.getLogBuilder());
			parser.parse();
			
			ArrayList<PbOCategory> collection = new ArrayList<PbOCategory>();
			collection.add(new ParameterCategory(parser.getParameters()));
			collection.add(new ChoiceCategory(parser.getChoices()));
			collection.add(new LogCategory(parser.getLogs()));
			
			return collection;
		} catch (IOException ex) {
			
		} catch (CoreException ex) {
			
		}
		
		return Collections.emptyList();
	}
}
