package pboweaverplugin.view.model;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;

public class PbOModelFactory {
	private PbOModelFactory() {
		super();
	}
	
	public static IPbOModel createModel() {
		System.out.println("Creating emtpy model");
		return new EmptyPbOModel();
	}
	
	public static IPbOModel createModel(IFile file) {
		if (file == null) {
			System.out.println("[WARNING] Null file in createModel");
			return createModel();
		}
		
		IProject project = file.getProject();
		IFile infoFile = project.getFolder("src").getFile("pbo.info");
		
		//System.out.println("f: "+file.getFullPath());
		
		if (!file.exists()) {
			System.out.println("[ERROR] Could not find file "+file.getName());
			return createModel();
		}
		
		System.out.println("Creating model with info file: "+infoFile);
		return new PbOModel(infoFile);
	}
}
