package pboweaverplugin.view.parser.fsm.choice;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;

import pboweaverplugin.view.model.Location;

public class ChoiceDeclaredState extends ChoiceParserState {
	Pattern declaredPattern = Pattern.compile("\\s*(.+):\\s*(.+)");
	
	public ChoiceDeclaredState(PbOChoiceFiniteStateMachine fsm) {
		super(fsm);
	}

	@Override
	public void parse(String line) {
		if (Pattern.matches(declaredPattern.pattern(), line)) {
			Matcher matcher = declaredPattern.matcher(line);
			matcher.matches();
			
			String filename = matcher.group(1);
			String[] lineNumbers = matcher.group(2).split(" ");
			
			IFile file = ResourcesPlugin.getWorkspace().getRoot().getFileForLocation(new Path(filename));
			
			for(String lineNumber: lineNumbers) {
				String[] beginningAndEnd = lineNumber.split("-");
				int beginning = Integer.parseInt(beginningAndEnd[0]);
				int end = Integer.parseInt(beginningAndEnd[1]);
				
				System.out.println("Found accessed: "+file+":"+beginning+" to "+end);
				
				Location loc = new Location(file, beginning);
				getContext().getBuilder().addAccessed(loc);
				
			}
		}
	}

}
