package pboweaverplugin.view.parser.fsm.choice;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ChoiceNameState extends ChoiceParserState {
	
	Pattern namePattern = Pattern.compile("(.+)");
	
	public ChoiceNameState(PbOChoiceFiniteStateMachine fsm) {
		super(fsm);
	}

	@Override
	public void parse(String line) {
		if (Pattern.matches(namePattern.pattern(), line)) {
			Matcher matcher = namePattern.matcher(line);
			matcher.matches();
			
			String name = matcher.group(1);
			
			System.out.println("Choice: "+name);
			
			getContext().getBuilder().setName(name);
		}
	}

}
