package pboweaverplugin.view.parser.fsm.choice;

import java.util.List;

import pboweaverplugin.view.constructs.AbstractPbOBuilder;
import pboweaverplugin.view.constructs.AbstractPbOObject;
import pboweaverplugin.view.constructs.PbOChoice;
import pboweaverplugin.view.parser.fsm.PbOParserFiniteStateMachine;

public class PbOChoiceFiniteStateMachine extends PbOParserFiniteStateMachine {
	
	ChoiceNameState nameState;
	ChoiceDeclaredState declaredState;
	
	ChoiceParserState currentState;

	public PbOChoiceFiniteStateMachine(AbstractPbOBuilder builder) {
		super(builder);
		
		nameState = new ChoiceNameState(this);
		declaredState = new ChoiceDeclaredState(this);
		
		currentState = nameState;
	}
	
	protected void addChoice(PbOChoice obj) {
		super.addObject(obj);
	}
	
	public List<AbstractPbOObject> getChoices() {
		return super.getObjects();
	}

	@Override
	public void parse(String line) {
		if (line.matches("\\s*declared:\\s*")) {
			currentState = declaredState;
			return;
		}
		
		if (line.matches("") && currentState == declaredState) {
			PbOChoice choice = (PbOChoice) getBuilder().build();
			addChoice(choice);
			
			currentState = nameState;
			return;
		}
		
		currentState.parse(line);
		
	}

}
