package pboweaverplugin.view.parser.fsm.log;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;

import pboweaverplugin.view.model.Location;
import pboweaverplugin.view.parser.fsm.ParserState;
import pboweaverplugin.view.parser.fsm.PbOParserFiniteStateMachine;

public class LogDeclaredState extends ParserState {
	Pattern accessedPattern = Pattern.compile("\\s+(.+?):\\s*(.*)");
	
	public LogDeclaredState(PbOParserFiniteStateMachine fsm) {
		super(fsm);
	}

	@Override
	public void parse(String line) {
		if (line.matches(accessedPattern.pattern())) {
			Matcher matcher = accessedPattern.matcher(line);
			matcher.matches();
			
			String filename = matcher.group(1);
			IFile file = ResourcesPlugin.getWorkspace().getRoot().getFileForLocation(new Path(filename));
			
			String[] lineNumbers = matcher.group(2).split(" ");
			
			for(String lineNumber: lineNumbers) {
				int lineNum = Integer.parseInt(lineNumber);
				Location loc = new Location(file, lineNum);
				
				getContext().getBuilder().addAccessed(loc);
				
				
			}
		}
		
	}

}
