package pboweaverplugin.view.parser.fsm.log;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import pboweaverplugin.view.parser.fsm.ParserState;
import pboweaverplugin.view.parser.fsm.PbOParserFiniteStateMachine;

public class LogNameState extends ParserState {
	Pattern namePattern = Pattern.compile("##(.+)");
	
	public LogNameState(PbOParserFiniteStateMachine fsm) {
		super(fsm);
	}

	@Override
	public void parse(String line) {
		if (line.matches(namePattern.pattern())) {
			Matcher matcher = namePattern.matcher(line);
			matcher.matches();
			
			String name = matcher.group(1);
			
			getContext().getBuilder().setName(name);
			
		}
		
	}

}
