package pboweaverplugin.view.parser.fsm.log;

import java.util.List;

import pboweaverplugin.view.constructs.AbstractPbOBuilder;
import pboweaverplugin.view.constructs.AbstractPbOObject;
import pboweaverplugin.view.constructs.PbOLog;
import pboweaverplugin.view.parser.fsm.ParserState;
import pboweaverplugin.view.parser.fsm.PbOParserFiniteStateMachine;

public class PbOLogFiniteStateMachine extends PbOParserFiniteStateMachine {

	LogNameState nameState;
	LogDeclaredState declaredState;
	ParserState currentState;
	
	public PbOLogFiniteStateMachine(AbstractPbOBuilder builder) {
		super(builder);
		
		nameState = new LogNameState(this);
		declaredState = new LogDeclaredState(this);
		
		currentState = nameState;
	}

	@Override
	public void parse(String line) {
		if (line.matches("\\s*declared:\\s*")) {
			currentState = declaredState;
			return;
		}
		
		if (line.matches("") && currentState == declaredState) {
			PbOLog log = (PbOLog) this.getBuilder().build();
			this.addObject(log);
			
			currentState = nameState;
			return;
		}
		
		currentState.parse(line);
		
	}

	public List<AbstractPbOObject> getLogs() {
		return this.getObjects();
	}

}
