package pboweaverplugin.view.parser.fsm.parameter;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;

import pboweaverplugin.view.model.Location;

public class ParamAccessedState extends ParamParserState {
	Pattern accessedPattern = Pattern.compile("\\s+(.+?):\\s*(.*)");
	
	public ParamAccessedState(PbOParameterFiniteStateMachine fsm) {
		super(fsm);
		// TODO Auto-generated constructor stub
	}

	@Override
	public void parse(String line) {
		if (Pattern.matches(accessedPattern.pattern(), line)) {
			Matcher accessedMatcher = accessedPattern.matcher(line);
			accessedMatcher.matches();
			
			String filename = accessedMatcher.group(1);
			IFile file = ResourcesPlugin.getWorkspace().getRoot().getFileForLocation(new Path(filename));
			
			String lineNumbers = accessedMatcher.group(2);
			String[] lines = lineNumbers.split(" ");
			
			System.out.println("All capture group: "+accessedMatcher.group(2));
			
			System.out.println("Group count: "+lines.length);
			
			for(String s: lines) {
				int lineNumber = Integer.parseInt(s);
				System.out.println("Found accessed: "+file+":"+lineNumber);
				
				//builder.addAccessed(new Location(file, lineNumber));
				
				getContext().getBuilder().addAccessed(new Location(file, lineNumber));
			}
			
		}
		
	}

}
