package pboweaverplugin.view.parser.fsm.parameter;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;

import pboweaverplugin.view.model.Location;
import pboweaverplugin.view.parser.fsm.PbOParserFiniteStateMachine;

public class ParamDeclaredState extends ParamParserState {
	Pattern declaredPattern = Pattern.compile("\\s+(.+?):\\s*(\\d+)");
	
	public ParamDeclaredState(PbOParserFiniteStateMachine fsm) {
		super(fsm);
	}

	@Override
	public void parse(String line) {
		if (Pattern.matches(declaredPattern.pattern(), line)) {
			Matcher declaredMatcher = declaredPattern.matcher(line);
			declaredMatcher.matches();
			String filename = declaredMatcher.group(1);
			
			IFile file = ResourcesPlugin.getWorkspace().getRoot().getFileForLocation(new Path(filename));
			int lineNumber = Integer.parseInt(declaredMatcher.group(2));
			
			//builder.setDeclared(new Location(file, lineNumber));
			
			getContext().getBuilder().setDeclared(new Location(file, lineNumber));
		}
		
		
		
	}

}
