package pboweaverplugin.view.parser.fsm.parameter;

import java.util.List;

import pboweaverplugin.view.constructs.AbstractPbOBuilder;
import pboweaverplugin.view.constructs.AbstractPbOObject;
import pboweaverplugin.view.constructs.PbOParameter;
import pboweaverplugin.view.parser.fsm.PbOParserFiniteStateMachine;

public class PbOParameterFiniteStateMachine extends PbOParserFiniteStateMachine {
	ParamNameState nameState;
	ParamDeclaredState declaredState;
	ParamAccessedState accessedState;
	
	ParamParserState currentState;

	public PbOParameterFiniteStateMachine(AbstractPbOBuilder builder) {
		super(builder);
		
		nameState = new ParamNameState(this);
		declaredState = new ParamDeclaredState(this);
		accessedState = new ParamAccessedState(this);
		
		currentState = nameState;
		
	}
	
	public void addParameter(PbOParameter obj) {
		super.addObject(obj);
	}
	
	public List<AbstractPbOObject> getParameters() {
		return super.getObjects();
	}

	@Override
	public void parse(String line) {
		if (line.matches("\\s*declared:\\s*")) {
			currentState = declaredState;
			return;
		}
		
		if (line.matches("\\s*accessed:\\s*")) {
			currentState = accessedState;
			return;
		}
		
		if (line.matches("") && currentState == accessedState) {
			PbOParameter param = (PbOParameter) getBuilder().build();
			addParameter(param);
			
			currentState = nameState;
			return;
		}
		
		currentState.parse(line);
		
	}

}
