package ca.ubc.cs.beta.pbo.eclipse.editor;

import java.util.HashSet;
import java.util.Set;

import org.eclipse.jface.text.rules.ICharacterScanner;
import org.eclipse.jface.text.rules.IPredicateRule;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.Token;

public class ExactMatchRule implements IPredicateRule {

	private Set<String> match = new HashSet<String>();
	
	private IToken successToken;
	
	private boolean checkWhitespaceFollows = false;
	
	public ExactMatchRule(String match, IToken successToken)
	{
		this.match.add(match);
		this.successToken = successToken;
	}
	
	

	public ExactMatchRule(Set<String> match, IToken successToken)
	{
		this.match.addAll(match);
		this.successToken = successToken;
	}

	public void setCheckWhitespaceFollows(boolean cwf)
	{
		this.checkWhitespaceFollows = cwf;
	}
	
	
	
	public IToken evaluate(ICharacterScanner arg0) {
		
		for(String matchX : match)
		{
			StringBuffer sb = new StringBuffer("");
			for(int i=0; i < matchX.length(); i++)
			{
				sb.append((char) arg0.read());
			}
			if(checkWhitespaceFollows)
			{
				char nextChar = (char) arg0.read();
				
				if(!Character.isWhitespace(nextChar))
				{
					arg0.unread(); //Unread what we just did
					
					//Unread everything we didn't match
					for(int i=0; i < matchX.length(); i++)
					{
						arg0.unread();
					}
					
					continue;
				}
			}
			
			if(matchX.equals(sb.toString()))
			{
				return getSuccessToken();
			} else
			{
				for(int i=0; i < matchX.length(); i++)
				{
					arg0.unread();
				}
			}
		}
		
		return Token.UNDEFINED;
	}


	public IToken evaluate(ICharacterScanner arg0, boolean arg1) {
		// TODO Auto-generated method stub
		return null;
	}


	public IToken getSuccessToken() {
		// TODO Auto-generated method stub
		return successToken;
	}

}
