package ca.ubc.cs.beta.pbo.eclipse.editor;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.jface.text.rules.IPredicateRule;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.RuleBasedPartitionScanner;

import org.eclipse.jface.text.rules.SingleLineRule;
import org.eclipse.jface.text.rules.Token;



public class PBOPartitionScanner extends RuleBasedPartitionScanner {
	public final static String PBO = "__pbo";
	
	public PBOPartitionScanner() {

		
		IToken pbo = new Token(PBO);
	
		//Folding
		List<IPredicateRule> rules = new LinkedList<IPredicateRule>();

		rules.add(new EntireLineRule("##PARAM(",")",pbo));
		rules.add(new EntireLineRule("##LOG(",")",pbo));
		rules.add(new EntireLineRule("##BEGIN CHOICE ","",pbo));
		rules.add(new EntireLineRule("##CHOICE","",pbo));
		rules.add(new EntireLineRule("##END CHOICE ","",pbo));
		
		//Read 50 characters
		rules.add(new RegExMatcher("\\A##\\S+",pbo,50));
		

		
		//rules.add(new SingleLineRule("##PARAM(", ")", pbo));
		/*
		rules.add(new SingleLineRule("##LOG(", ")", pbo));
		rules.add(new SingleLineRule("##BEGIN","\n", pbo));
		rules.add(new SingleLineRule("##END", "\n", pbo));
		//rules.add(new SingleLineRule("\n##PARAM(", ")", pbo));
		rules.add(new SingleLineRule("\n##LOG(", ")", pbo));
		rules.add(new SingleLineRule("\n##BEGIN","\n", pbo));
		rules.add(new SingleLineRule("\n##END", "\n", pbo));
		rules.add(new SingleLineRule("\n##END", "\n", pbo));
		rules.add(new JavaIdentifierRule(pbo)); 
		*/
		
		
		setPredicateRules(rules.toArray(new IPredicateRule[0]));
		
	}
}