package ca.ubc.cs.beta.pbo.eclipse.editor;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.eclipse.jface.text.rules.ICharacterScanner;
import org.eclipse.jface.text.rules.IPredicateRule;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.Token;

public class RegExMatcher implements IPredicateRule{

		private String regEx;
		private IToken successToken;
		private Pattern pattern;
		private int searchSpace;
		
		/**
		 * 
		 * @param regEx Regular Expression must match from start of input
		 * @param successToken
		 */
		public RegExMatcher(String regEx, IToken successToken, int searchSpace)
		{
			this.regEx = regEx;
			
			this.successToken = successToken;
			this.pattern = Pattern.compile(regEx);
			this.searchSpace = searchSpace;
			

		}
		

		public IToken evaluate(ICharacterScanner arg0) {
			
			int undos = 0;

			
			StringBuffer sb = new StringBuffer("");
			//This probably won't work under Windows or MAC OS X
			char input; 
			
			
			for(int i=0; i<searchSpace; i++)
			{
				sb.append((char) arg0.read());
			}
			
			
			for(int i=0; i <searchSpace; i++)
			{ //Rewind back to start;
				arg0.unread();
			}
			
	        Matcher matcher = pattern.matcher(sb.toString());
	        
	        
	        
	        
			if(matcher.find())
			{
				
				if (matcher.start() != 0)
				{
					//We need to match on the first character not just somewhere in the region
					System.err.println("WARNING: Regular Expression did not match on first character [RegExMatcher.java]");
				}
			
				for(int i=0; i < matcher.end(); i++)
				{
					arg0.read();
				}
				return getSuccessToken();
				
				
			} else
			{
				return Token.UNDEFINED;
			}
			
					
			
			
		}

	
		public IToken evaluate(ICharacterScanner arg0, boolean arg1) {

			return evaluate(arg0);
			//throw new UnsupportedOperationException("Can't evaluate in the middle of the line");
		}

	
		public IToken getSuccessToken() {
			// TODO Auto-generated method stub
			return successToken;
		}

}


