package ca.ubc.cs.beta.pbo.eclipse.editor;


import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

import org.eclipse.jface.text.rules.ICharacterScanner;
import org.eclipse.jface.text.rules.IPredicateRule;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.Token;

public class TypeRule implements IPredicateRule {

	private IToken successToken;
	public static final Set<String> validTypes;
	
	static {
		Set<String> validTypesX = new HashSet<String>();
		validTypesX.add("int");
		validTypesX.add("integer");
		validTypesX.add("real");
		validTypesX.add("float");
		validTypesX.add("char");
		validTypesX.add("character");
		validTypesX.add("str");
		validTypesX.add("string");
		validTypesX.add("boolean");
		validTypesX.add("bool");
		validTypes = Collections.unmodifiableSet(validTypesX);
		
	}
	public TypeRule(IToken successToken)
	{
		this.successToken = successToken;
		
		
	}
	

	public IToken evaluate(ICharacterScanner arg0) {
		// TODO Auto-generated method stub
		if(String.valueOf( (char) arg0.read()).trim().length() == 0)
		{
			return Token.WHITESPACE;
		} else
		{
			arg0.unread();
		}
		StringBuffer sb = new StringBuffer();
		while(sb.toString().trim().length() <= 9)
		{
			
			sb.append((char) arg0.read());
			
			
			char nextChar = (char) arg0.read();
			
			if ((nextChar != ' ') && (nextChar != '['))
			{
				arg0.unread();
				continue;
			} else
			{
				
				String result = sb.toString().trim();
				
				if(validTypes.contains(result))
				{
					return getSuccessToken();
				} else if(result.length() == 0)
				{
					return Token.WHITESPACE;
				} else
				{
					return Token.UNDEFINED;
				}				
			}
		}
		
		return Token.UNDEFINED;
	}


	public IToken evaluate(ICharacterScanner arg0, boolean arg1) {
		// TODO Auto-generated method stub
		return Token.UNDEFINED;
	}

	
	public IToken getSuccessToken() {

		return successToken;
	}

}
